DEFine fn backup_file% (bsource$,bdest$,repchan%,do_cls%)
rem backup one file
rem returns 1 if backup ok, 0 if not
rem backup_address and backup_size are from caller
LOCal chani%,fidate,filength,address,fitype,fidata,temp%,chano%
  if do_cls%
    pe_cls#repchan%
    at#repchan%,1,0:pe_print#repchan%,"Backing up: "&chr$(10)&bsource$
  endif
  chani%=fop_in(bsource$)
  if chani%<0
    dr_unst warn_defn
    temp%=warning% ("Couldn't backup file : "&bsource$& "  "&errstr$(chan%),repchan%,"Error")
    info "",repchan%
    return  0
  endif
  filength=flen(#chani%)
  if filength>backup_size
     rechp backup_address
     backup_address=alchp(filength)
     backup_size=filength
  endif
  lbytes bsource$,backup_address
  sbytes_o bdest$,backup_address,filength
  chano%=fopen( bdest$)
  copyhdr #chani%,#chano%
  close#chani%
  close#chano%
  return 1
END DEFine backup_file%
:
def proc backup (choice%,item%,chan%, verify%)
rem choice% is the choice from the right click menu
local result_count%,a$,sourcelen%,lp%,result_ok%,s_dev$,b$,status%
local backup_address,backup_size,err_chan%,were_errors%,ef$,verif_err
  result_count%=0			: rem will contain the nbr of files to backup
  info "Creating arrays",chan%
  dim backup$(dimn(result$,1),dimn(result$,2))
  setup_backup choice%,item%		: rem fill in the backup$ array
  if result_count%=0:return		: rem nothing to backup
  if options%(4)>20
     pe_cls#chan%,3
     at#chan%,2,0:pe_print#chan%,"Creating directories"
     result_ok%=create_missing_directories%(chan%) : rem actually <> 0 if NOT OK
     if result_ok%
	result_ok%=fop_over("ram1_wlBackupwlxxx1")
	if result_ok%>-1
	   print#result_ok%,errdir$
	   close#result_ok%
	endif
	result_ok%=warning%(sometexts$(0)&chr$(10)&sometexts$(1)&chr$(10)&sometexts$(2),chan%,sometexts$(3))
	if result_ok%=0:return
	info "Starting backup",chan%
      endif
  endif
  backup_size=100000
  backup_address=alchp(backup_size)
  sourcelen%=len(source$)-5
  s_dev$=source$(1 to 5)
  for lp%=0 to result_count%-1
    a$=backup$(lp%)
    if sourcelen%
       b$=a$(sourcelen%+1 to)
    else
       b$=a$
    endif
    if (lp% mod 100) = 0
	result_ok%=backup_file%( s_dev$&a$,dest$&b$,chan%,1)
    else
	result_ok%=backup_file%( s_dev$&a$,dest$&b$,chan%,0)
    endif
  end for lp%
  if options%(3)<>0
    if options%(2)>20
       change_all_copied_statusses 17		: rem all selected everywhere to unavailable
    else
      change_copied_status_in_current_tab 17	: rem in current tab only
    endif
  endif
  rechp backup_address
  if verify%
    pe_cls#chan%
    ef$="ram1_x___BACKUP___x_VERIF_ERRORS"
    err_chan%=fop_over(ef$)
    if (err_chan%<0)
       were_errors%=warning%("Couldn't open error file"& chr$(10)&"No verification will take place",chan%,"Error")
    else
      were_errors%=0
      verif_ok=0
      for lp%=0 to result_count%-1
	a$=backup$(lp%)
	if sourcelen%
	   b$=a$(sourcelen%+1 to)
	else
	   b$=a$
	endif
	if (lp% mod 100) = 0
	  pe_cls#chan%
	  pe_print#chan%,chr$(10)&"Verifying..." &chr$(10)&  b$
	endif
	verif_err=fcompa(s_dev$&a$,dest$&b$,1)
	if verif_err
	  were_errors%=1
	  print#err_chan%,a$;get_reason$(verif_err)
	endif
      end for lp%
      close#err_chan%
      if were_errors%
	 were_errors%=warning%("There were verification errors"&chr$(10)&"The file list is in"&chr$(10)&ef$,chan%,"Error")
      else
	delete ef$
	dr_unst warn_defn
      endif
    endif
  else
    dr_unst warn_defn
  endif
  get_new_statusses
end def backup
:
def proc setup_backup (choice%,item%)
rem determines which files must be backed up, and
rem puts the result into a global var backup$ created here
local lp%
  dim backup$(dimn(result$,1),dimn(result$,2))
  select on choice%
    = 0 : rem backup only this file
	result_count%=1
	backup$(0)=get_file$(item%)
    = 1 : rem backup all selected files of current tab
	backup_current_tab 0
    = 2 : rem backup all files of current tab
	backup_current_tab 1
    = 3 : rem backup all selected files of all tabs
	backup_all_tabs 0
    = 4 : rem backup all files in all tabs
	backup_all_tabs 1
  end select
end def setup_backup
:
def proc backup_current_tab (do_all%)
rem backup the current tab, as determined by current choice
rem do_all% <>01 if all files in this tab are to be abcked up, else only the selected ones
  select on current_choice%
    =0: get_files_to_backup result$ ,tot_objs%,do_all%
    =1: get_files_to_backup nonexistent$, non_ext%,do_all%
    =2: get_files_to_backup typediff$, type_d% ,do_all%
    =3: get_files_to_backup lengthdiff$,length_d% ,do_all%
    =4: get_files_to_backup diffdate$, date_d% ,do_all%
    =5: get_files_to_backup contdiff$,cont_d%,do_all%
rem    =6: get_files_to_backup impossible$,imp_d%,do_all% : rem this doesn't make sense
  end select
end def backup_current_tab
:
def proc backup_all_tabs (do_all%)
local oldchoice%,lp%
  if do_all%
    backup_all_files
    change_all_statusses 17
  else
    oldchoice%=current_choice%
    for lp% = 0 to 5
       current_choice%=lp%	: rem lp% shouldn't be extended to 6 as that tab can't be backed up
       backup_current_tab do_all%
    end for lp%
  endif
end def backup_all_tabs
:
def fn get_file$(item%)
  select on current_choice%
    =0: return strip_spaces$(result$(item%+1,1 to name_length%)) : rem if in "all" tab
    =1: return strip_spaces$(nonexistent$(item%+1,1 to name_length%))
    =2: return strip_spaces$(typediff$(item%+1,1 to name_length%))
    =3: return strip_spaces$(lengthdiff$(item%+1,1 to name_length%))
    =4: return strip_spaces$(diffdate$(item%+1,1 to name_length%))
    =5: return strip_spaces$(contdiff$(item%+1,1 to name_length%))
    = remainder : return ""
  end select
end def get_file$
:
def proc get_files_to_backup (string$,flags%,do_all%)
rem this fills the backup$ array with the names of the source files to backup
local lp%,a$
  for lp%=0 to dimn(flags%,1)
    if (do_all%) or (flags%(lp%,0) >1)
	a$=strip_spaces$(string$(lp%+1,1 to name_length%)) : rem the file to backup
	if a$<>"" and asearch(backup$,a$,0,0)=-1
	   backup$(result_count%)=a$	: rem put it into result array but only if it isn't there aleady
	   result_count%=result_count%+1
	endif
	if do_all%:flags%(lp%,0)=128
    endif
  end for lp%
end def get_files_to_backup
:
def proc backup_all_files
rem backing up all files is easy: just backup all files in the "all" tab
local lp%
  result_count%= dimn(result$,1)-1
  for lp%=0 to result_count%
    backup$(lp%)=strip_spaces$(result$(lp%+1,1 to name_length%))
  end for lp%
end def backup_all_files
:
def fn get_reason$ (result)
local a$
  a$=" : "
  if (result &&  2)
    return a$&" file doesn't exist on drive 2"
  endif
  if (result && 64) and (options%(0)<2 )
     a$=a$&"source file is older than dest file"
  endif
  if result && 128
     a$=a$&"dest file is older than source file"
  endif
  if result && 16
     a$=a$&"files of different type"
  endif
  if result && 32
     a$=a$&"files of different length"
  endif
  if result && 256
     a$=a$&"files have different content"
  endif
  return a$
end def get_reason$
:
