DEFine PROCedure compare_drives  (drive1$,drive2$,deepscan%,chan%)
local temp%,tempchan%,cname$,lp%,b$,cnm$
  if name_wrong%(drive1$)
    temp%=warning%("Source isn't on a valid drive",chan%,"Error")
    return
  endif
  if name_wrong%(drive2$)
    temp%=warning%("Destination isn't a valid drive",chan%,"Error")
    return
  endif
  allcount%=0		 : rem no files found yet
  necount=0
  dlcount=0
  ddcount=0
  difcount=0
  tdcount=0
  impcount=0
:
  dim all_dirs$(10,name_length%): rem array with names of all dirs perused
  all_dirs_count%=0		: rem how many dirs
:
  info "Scanning :",chan%
  if source$(1 to 5) =="ram1_"
     cname$="ram8_sc001"
  else
     cname$="ram1_sc001"
  endif
  for lp%= 1 to 100
     cname$=cname$&rnd(1 to 20000)
     tempchan%=fop_over(cname$)
     if tempchan%>0:exit lp%
  end for lp%
  if tempchan%<0
    dr_unst warn_defn
    result=warning%("Can't open "&cname$&chr$(10)&"unable to proceed",chan%,"Error")
    return
  endif
  compare_dir drive1$,drive2$,1,deepscan%,exclude$,chan%,cname$(1 to 5)
  get#tempchan%\0
  dim result$(allcount%+1,string_length%)
  result$(0)=allcount%
  cls#chan%
  if allcount%=0
rem    close#tempchan%
rem    delete cname$
    cls# chan%
    print #chan%,"Nothing to do"
    print #chan%;"Hit a key to continue"
    b$=inkey$(#chan%,-1)
    dim result$(1,66)
    result$(0)=0
  else
    print#chan%,"Loading ..."
    for lp%=1 to allcount%
      input#tempchan%,result$ (lp%)
    end for lp%
  endif
  close#tempchan%
  delete cname$
  dim xcoords%(0,1)
  if allcount%<>0
    cls#chan%
    print#chan%, "Making lists..."
    split_results chan%
    dr_unst warn_defn
    current_choice%=-1
    appsub_show_selected_data 0,chan%
    opentab%=0
    current_choice%=0
    current_sort%(0)=0
    draw_tab_appsub chan%,opentab%
  else
    dr_unst warn_defn
    current_choice%=-1
    mk_main_app result$
rem    appsub_show_selected_data 0,chan%
    dr_idrw main_defn,-5
    draw_tab_appsub chan%,-1
    current_sort%(0)=-1 		: rem stops appsub from being redrawn
  endif
  draw_sort_appsub chan%,opentab%
END DEFine compare_drives
:
def proc split_results	(chan%)
rem splits the results into several arrays, depending on the type of the result
local count,lp%,a$,type%,tot,wdwdef%(3),counts(6),xc%
  dim nonexistent$(necount+1,string_length%)
  dim lengthdiff$(dlcount+1,string_length%)
  dim diffdate$(ddcount+1,string_length%)
  dim contdiff$(difcount+1,string_length%)
  dim typediff$(tdcount+1,string_length%)
  dim impossible$(impcount+1,string_length%)
  if allcount%=0:return
  necount=0
  dlcount=0
  ddcount=0
  difcount=0
  tdcount=0
  impcount=0
  for lp%=1 to allcount%
    a$=result$(lp%,string_length%)
    if a$="":next lp%:exit lp%
    type%=code(a$)-97
    select on type%
	=0 : rem non existent on drive 2
	  necount=necount+1
	  nonexistent$(necount)=result$(lp%)
	=1 : rem different type
	  tdcount=tdcount+1
	  typediff$(tdcount)=result$(lp%)
	=2 : rem different length
	  dlcount=dlcount+1
	  lengthdiff$(dlcount)=result$(lp%)
	=3,4 : rem different dates
	  ddcount=ddcount+1
	  diffdate$(ddcount)=result$(lp%)
	=5 : rem different content
	  difcount=difcount+1
	  contdiff$(difcount)=result$(lp%)
	=6 : rem impossibly long filename
	  impcount=impcount+1
	  impossible$(impcount)=result$(lp%)
    end select
  end for lp%
  nonexistent$(0)=necount
  lengthdiff$(0)=dlcount
  diffdate$(0)=ddcount
  contdiff$(0)=difcount
  typediff$(0)=tdcount
  impossible$(0)=impcount
  tot=0+(allcount%<>0)+(necount<>0)+(dlcount<>0)+(ddcount<>0)+(difcount<>0)+(tdcount<>0)+(impcount<>0)
  wsipo#chan%,wdwdef%		: rem get wdw size & position
  xs%=(wdwdef%(0)-4) div tot	: rem space for one tab
  counts(0)=necount:counts(1)= tdcount:counts(2)= dlcount
  counts(3)= ddcount:counts(4)=difcount
  counts(5)=impcount
  dim what_types%(tot)
  dim tot_objs% (allcount%-1,1)    : rem if we get here allcount<>0
  for lp%=1 to tot
    if counts(0):what_types%(lp%)=1:dim non_ext%(counts(0)-1,1):counts(0)=0:next lp%:exit lp%
    if counts(1):what_types%(lp%)=2:dim type_d%(counts(1)-1,1):counts(1)=0:next lp%:exit lp%
    if counts(2):what_types%(lp%)=3:dim length_d%(counts(2)-1,1):counts(2)=0:next lp%:exit lp%
    if counts(3):what_types%(lp%)=4:dim date_d%(counts(3)-1,1):counts(3)=0:next lp%:exit lp%
    if counts(4):what_types%(lp%)=5:dim cont_d%(counts(4)-1,1):counts(4)=0
    if counts(5):what_types%(lp%)=6:dim imp_d%(counts(5)-1,1):counts(5)=0
  end for lp%
end def split_result$
:
def fn name_wrong% (nm$)
 if len(nm$)<5 : return 1
 if nm$(5)<>"_": return 1
 return 0
 end def name_wrong%
