def proc do_sort (sort_crit%,tab%)
rem sorts the data. This is done as follows: if one clicks on the column header
rem which is the current sort key, the sort is inversed. If one clicks on a new column
rem header, this columnis used for sorting, in ascending order.
local temp%
  current_choice%=what_types%(tab%)	 : rem which array will we be sorting?
  select on sort_crit%
      =0	     : temp%=0
      =name_length%+2: temp%=1
      =remainder     : temp%=2
  end select
  if current_sort%(tab%)=sort_crit%
    sort_dir%(tab%,temp%)=not sort_dir%(tab%,temp%): rem here we inverse the sort
    select on current_choice%
      =0 : arrinv result$
      =1 : arrinv nonexistent$
      =2 : arrinv typediff$
      =3 : arrinv lengthdiff$
      =4 : arrinv diffdate$
      =5 : arrinv contdiff$
    end select
    arrinv main_mfl%				: rem also inverse the flags array
  else
    sort_dir%(tab%,temp%)=0
    select on current_choice%
      =0: set_status_in_string result$
	  qsortf result$,sort_crit%,1,sort_dir%(tab%,temp%)
	  get_status_from_string result$
      =1: set_status_in_string nonexistent$
	  qsortf nonexistent$,sort_crit%,1,sort_dir%(tab%,temp%)
	  get_status_from_string nonexistent$
      =2: set_status_in_string typediff$
	  qsortf typediff$,sort_crit%,1,sort_dir%(tab%,temp%)
	  get_status_from_string typediff$
      =3: set_status_in_string lengthdiff$
	  qsortf lengthdiff$,sort_crit%,1,sort_dir%(tab%,temp%)
	  get_status_from_string lengthdiff$
      =4: set_status_in_string diffdate$
	  qsortf diffdate$,sort_crit%,1,sort_dir%(tab%,temp%)
	  get_status_from_string diffdate$
      =5: set_status_in_string contdiff$
	  qsortf contdiff$,sort_crit%,1,sort_dir%(tab%,temp%)
	  get_status_from_string contdiff$
    end select
  endif
  main_cty%(0,1)=1
  dr_adrw main_defn,0,main_mfl%,main_cty%	: rem redraw window
  dr_ascr main_defn,appsubs(0)			: rem and scroll bars etc
  main_cty%(0,1)=0
  current_sort%(tab%)=sort_crit%
end def do_sort
:
def proc set_status_in_string(array$)
rem this sets the status of the item in the string, so that we can reset this afterwards
local lp%,where%
  where%=string_length%-1
  for lp%=0 to dimn(main_mfl%,1)
    if main_mfl%(lp%,0)=0
      array$(lp%+1,where%)="0"
    else
      array$(lp%+1,where%)="1"
    endif
  end for lp%
end def set_status_in_string
:
def proc get_status_from_string (array$)
rem this sets the status of the item in the flag array, after getting it from the string
local lp%,where%,b$
  where%=string_length%-1
  for lp%=0 to dimn(main_mfl%,1)
    b$=array$(lp%+1,where%)
    if b$="0"
      main_mfl%(lp%,0)=0
    else
      main_mfl%(lp%,0)=128
    endif
  end for lp%
end def get_status_from_string
:
